;Erweiterung der Ausgabe-Funktionalitt fr LCD fr AVR-Assembler (AT-Mega).
;Dieser Include-Code ist Bestandteil LCD-Ausgaberoutinensammlung "print.inc".
;Diese Datei braucht die Datei "pr_i2a16.inc" zur Fortsetzung.

;Die Datenausgaberoutine des LCD-Treibers sollte "lcd_data" heien.
;Das auszugebende ASCII-Zeichen steht im Register "tmp", das im Hauptprogramm
;eingerichtet werden muss.

;Verwendete Register und SRAM:
;  Reg.: tmp (wird nicht gesichert)
;        wh, xh, xl und yl (wird gesichert)
;  SRAM: tmpmath(0,1,2)
;-----------------------------------------------------------------------------

;Es werden folgende Funktionen bereitgestellt,
;die per Macro aufgerufen werden:
;-----------------------------------------------------------------------------
;  print24 H-reg,M-Reg,L-Reg,Komma,[using]+[sig]+[fnul]
                        ;Gibt 24-Bit-Zahl als Ziffern aus
                        ;H-Reg,M-Reg,L-Reg enthlt die Zahl
                        ;Komma ist die Anzahl der Nachkommastellen
                        ;using erzwingt formatierte Ausgabe (Print Using)
                        ;sig erzwingt Vorzeichen
                        ;fnul erzwingt Fhrungsnullen
;-----------------------------------------------------------------------------
;  print24s Adr,Komma,[using]+[sig]+[fnul]
                        ;Gibt 24-Bit-Zahl aus SRAM als Ziffern aus
                        ;Adr, Adr+1 und Adr+2 (SRAM) enthlt die Zahl (L:M:H)
                        ;Komma ist die Anzahl der Nachkommastellen
                        ;using erzwingt formatierte Ausgabe (Print Using)
                        ;sig erzwingt Vorzeichen
                        ;fnul erzwingt Fhrungsnullen
;-----------------------------------------------------------------------------

.macro print24 ;H-Reg,M-Reg,L-Reg,Kommastellen,using+sign+fnul
 sts tmpmath,@2
 sts tmpmath+1,@1
 sts tmpmath+2,@0
 ldi tmp,(@4 & $e0)|16|(9-(@3 & 15)) ;Mode-Flags und Komma-Position
 rcall lcd_print24          ;Aufruf
.endmacro


.macro print24s ;Adresse,Kommastellen,using+sign+fnul
 lds tmp,@0+2                ;Byte3
 sts tmpmath+2,tmp           ;kopieren
 lds tmp,@0+1                ;Byte2
 sts tmpmath+1,tmp           ;kopieren
 lds tmp,@0                  ;Low-Byte
 sts tmpmath,tmp             ;kopieren
 ldi tmp,(@2 & $e0)|16|(9-(@1 & 15))  ;Mode-Flags und Komma-Position direkt
 rcall lcd_print24          ;Aufruf
.endmacro

;-----------------------------------------------------------------------------

lcd_print24:            ;Wird von Macro aufgerufen.
                        ;Gibt Word als Zahl in mehreren Modi aus
 push xh                    ;verwendete Register
 push xl                    ;sichern
 push wh
 push yl
 mov wh,tmp                 ;direkt bergebenes Format-Bitmuster kopieren
 lds xl,tmpmath             ;Low-Byte
 lds xh,tmpmath+1           ;Byte2
 lds yl,tmpmath+2           ;Byte3
/*
; sbrs wh,6                  ;Signum-Flag gesetzt? ja...
 rjmp lcd_print24u          ;nein, als unsigned behandeln...
 sbrs yl,7                  ;Wert negativ? ja...
 rjmp lcd_print24plus       ;nein, positiv...
 ldi tmp,'-'                ;Vorzeichen
 rcall lcd_data             ;ausgeben
 neg xl                     ;Zahl positiv
 com xh                     ;machen
 rjmp lcd_print24u          ;weiter...
lcd_print24plus:        ;Pluszeichen ausgeben
 ldi tmp,'+'                ;Pluszeichen
 rcall lcd_data             ;an LCD
*/
lcd_print24u:           ;24-Bit-Zahl zerlegen
 ldi tmp,-1+'0'             ;Ziffer fr ZehnMillon
 inc tmp                    ;ZehnMio Stelle hoch und
 subi xl,low(10000000)      ;von Zahl 10 Mio subtrahieren
 sbci xh,high(10000000)     ;bis Unterlauf
 sbci yl,byte3(10000000)    ;
 brcc pc-4                  ;Unterlauf? nein...
; rcall lcd_format           ;ja, Ziffer ausgeben (Zehn-Mio)
 ldi tmp,10+'0'             ;Ziffer fr Million, Zahl ist jetzt <0
 dec tmp                    ;Mio Stelle verkleinern und
 subi xl,low(-1000000)      ;1 Mio zur (<0) Zahl addieren,
 sbci xh,high(-1000000)     ;bis berlauf
 sbci yl,byte3(-1000000)    ;
 brcs pc-4                  ;berlauf? ja...
; rcall lcd_format           ;nein, Ziffer ausgeben (1 Mio)
 ldi tmp,-1+'0'             ;Ziffer fr Hunderttausender
 inc tmp                    ;Hunderttausender Stelle hoch und
 subi xl,low(100000)        ;von Zahl 100000 subtrahieren
 sbci xh,high(100000)       ;bis Unterlauf
 sbci yl,byte3(100000)      ;
 brcc pc-4                  ;Unterlauf? nein...
 rcall lcd_format           ;ja, Ziffer ausgeben (Hunderttausender)
 ldi tmp,10+'0'             ;Ziffer fr Tausender, Zahl ist jetzt <0
 dec tmp                    ;Tausender Stelle verkleinern und
 subi xl,low(-10000)        ;1 Mio zur (negativen) Zahl addieren,
 sbci xh,high(-10000)       ;bis berlauf
 sbci yl,byte3(-10000)      ;
 brcs pc-4                  ;berlauf? ja...
 subi xl,low(10000)         ;nein, 10000 von der (>0) Zahl subtrahieren,
 sbci xh,high(10000)        ;Zahl wieder <0 wird und ins Raster der 16-Bit-
 pop yl                     ;Routine passt, Variable von Byte3 entsorgen
 rjmp lcd_print16_a         ;16-Bit-Routine zerlegt den Rest...

